#include <stdio.h>
//#include "Fluid.h"
//#include "ParticleUpdate.h"
//#include "SerialUpdate.h"
#include "ParticleSystem.h"
#define SIDES 32
#define BOTTOM_BOUND -2.1f

// MEMBERS
//      Particle particles[MAX_PARTICLES]; /* Keeps track of all the particles */
//      unsigned int numParticles;         /* Current number of particles alive */
//      my_vec3 gravity;                      /* Particle System affects particles */
//      my_vec3 wind;
//      float milestone;                    /* How long a particle can live */
//      char* TextureFile;                 /* Name of the texture file */

//Particle System Functions/
ParticleSystem::ParticleSystem(float milestone, char* Texture) :
   milestone(milestone),
   TextureFile(Texture)
{}

void ParticleSystem::initalize() {
  srand(time(NULL));

  float particleYPos = SIDES - 5;
  float particleXPos = -SIDES;
  float particleZPos = SIDES;
  int particleCount = 1;

  for (int i = 0; i < NUM_PARTICLES; i++) {
    if(i < NUM_PARTICLES/2) {   
      particles[i].position.x = -0.5;
      particles[i].position.y = -2;
      particles[i].position.z = -4;
      particles[i].velocity.x = -rand()%4 + rand()/(float)RAND_MAX;
      particles[i].velocity.y = rand()%5 - rand()/(float)RAND_MAX;
      particles[i].velocity.z = -rand()%3 + rand()/(float)RAND_MAX - 3;
    }
    else {
      particles[i].position.x = 0.5;
      particles[i].position.y = -2;
      particles[i].position.z = -4;
      particles[i].velocity.x = rand()%4 - rand()/(float)RAND_MAX;
      particles[i].velocity.y = rand()%5 - rand()/(float)RAND_MAX;
      particles[i].velocity.z = -rand()%3 + rand()/(float)RAND_MAX - 3;
    }
    particles[i].radius = RADIUS;
    particleCount++;
  }
}

void updateParticleKernelS(Particle *particles, my_vec3 extForce) {
   float deltaTime = 0.1;
   int idx;
   for (idx = 0; idx < NUM_PARTICLES; idx++) {
      particles[idx].velocity.x = particles[idx].velocity.x + extForce.x * deltaTime;
      particles[idx].velocity.y = particles[idx].velocity.y + extForce.y * deltaTime;
      particles[idx].velocity.z = particles[idx].velocity.z + extForce.z * deltaTime;
      
      particles[idx].position.x = particles[idx].position.x + particles[idx].velocity.x * deltaTime;
      particles[idx].position.y = particles[idx].position.y + particles[idx].velocity.y * deltaTime;
      particles[idx].position.z = particles[idx].position.z + particles[idx].velocity.z * deltaTime;
  
      if (particles[idx].position.y <= BOTTOM_BOUND) {
         particles[idx].position.y = BOTTOM_BOUND;
         if(idx < NUM_PARTICLES/2) {   
            particles[idx].position.x = -0.5;
            particles[idx].position.y = -2;
            particles[idx].position.z = -3;
            particles[idx].velocity.x = -rand()%4 + rand()/(float)RAND_MAX;
            particles[idx].velocity.y = rand()%5 - rand()/(float)RAND_MAX;
            particles[idx].velocity.z = -rand()%3 + rand()/(float)RAND_MAX - 3;
         }
         else {
            particles[idx].position.x = 0.5;
            particles[idx].position.y = -2;
            particles[idx].position.z = -3;
            particles[idx].velocity.x = rand()%4 - rand()/(float)RAND_MAX;
            particles[idx].velocity.y = rand()%5 - rand()/(float)RAND_MAX;
            particles[idx].velocity.z = -rand()%3 + rand()/(float)RAND_MAX - 3;
         }
      }
   }
}

void ParticleSystem::update(float deltaTime) {
    my_vec3 grav;
    grav.x = 0.0f;
    grav.y = -2.3f;
    grav.z = 0.0f;

    updateParticleKernelS(particles, grav);
}
