struct Material {
  vec3 aColor;
  vec3 dColor;
  vec3 sColor;
  float shine;
};

uniform int phong;

varying vec4 vNorm;
varying vec4 vLight;
varying vec4 vView;
varying vec4 vRefl;
varying vec4 color;

uniform int normalOn;
uniform Material uMat;
uniform vec3 uLColor;

void main() {
  vec4 normNorm = normalize(vNorm);
  vec4 normLight = normalize(vLight);
  vec4 normView = normalize(vView);
  vec4 normRefl = normalize(vRefl);

  gl_FragColor = vec4(max(dot(normNorm, normLight), 0.0)*uLColor*uMat.dColor + pow(max(dot(normView, normRefl), 0.0), uMat.shine)*uLColor*uMat.sColor + uMat.aColor*uLColor, 1);
}
