struct Material {
  vec3 aColor;
  vec3 dColor;
  vec3 sColor;
  float shine;
};

attribute vec3 aPosition;
attribute vec3 aNormal;

varying vec4 vLight;
varying vec4 vView;
varying vec4 vRefl;
varying vec4 color;
varying vec4 vNorm;

uniform mat4 uProjMatrix;
uniform mat4 uViewMatrix;
uniform mat4 uModelMatrix;
uniform vec3 uLightPos;
uniform vec3 uLColor;
uniform vec3 uView;
uniform Material uMat;

void main() {
  vec4 vPosition;
  vec4 light;
  vec3 Refl;
  vec3 Spec, Diffuse;
  vec4 tmpNormal;
  vec4 rVec;
  vec4 tmpVPos;

  /* First model transforms */
  vPosition = uModelMatrix* vec4(aPosition.x, aPosition.y, aPosition.z, 1);
  light = vec4(uLightPos, 1) - vPosition;
  light = normalize(light);
  vPosition = uViewMatrix* vPosition;
  tmpVPos = vec4(uView, 1) - vPosition;
  gl_Position = uProjMatrix*vPosition;
  tmpNormal = uModelMatrix*vec4(aNormal.x, aNormal.y, aNormal.z, 0);
  tmpNormal = normalize(tmpNormal);
  rVec = -light + 2.0*(max(dot(light, tmpNormal), 0.0))*tmpNormal;
  rVec = normalize(rVec); 
  tmpVPos = normalize(tmpVPos);
  vView = tmpVPos;
  vLight = light;
  vRefl = rVec;
  vNorm = tmpNormal;

  color = vec4(max(dot(tmpNormal, light), 0.0)*uLColor*uMat.dColor + pow(max(dot(tmpVPos, rVec), 0.0), uMat.shine)*uLColor*uMat.sColor + uMat.aColor*uLColor, 1);
  
}
